property photoPath, logoPath, bioPath, layoutPath, ProNotePath, photoExt, logoExt, bioExt, layoutExt, ProNoteExt
global photoDL, logoDL, bioDL, layoutDL, ProNoteDL, saveMode, downloadList

on getPropertyDescriptionList
  description = [#photoPath: [#comment: "Path of image source files relative to movie", #default: "Images", #format: #string], #photoExt: [#comment: "Image files extension", #default: ".tif", #range: [".tif", ".psd", ".jpg", ".eps", ".pct"], #format: #string], #logoPath: [#comment: "Path of logo source files relative to movie", #default: "Logos", #format: #string], #logoExt: [#comment: "Logo files extension", #default: ".eps", #range: [".tif", ".psd", ".jpg", ".eps", ".pct", ".ai"], #format: #string], #bioPath: [#comment: "Path of bio source files relative to movie", #default: "Biographies", #format: #string], #bioExt: [#comment: "Bio files extension", #default: ".rtf", #range: [".rtf", ".doc", ".pdf", ".txt"], #format: #string], #layoutPath: [#comment: "Path of layout source files relative to movie", #default: "Layouts", #format: #string], #layoutExt: [#comment: "Layout files extension", #default: ".eps", #range: [".tif", ".psd", ".jpg", ".eps", ".pct", ".ai", ".pdf"], #format: #string], #ProNotePath: [#comment: "Path of ProNote source files relative to movie", #default: "Production Notes", #format: #string], #ProNoteExt: [#comment: "ProNote files extension", #default: ".rtf", #range: [".rtf", ".doc", ".pdf", ".txt"], #format: #string]]
  return description
end

on beginSprite me
  photoPath = the moviePath & fixPath(photoPath)
  logoPath = the moviePath & fixPath(logoPath)
  bioPath = the moviePath & fixPath(bioPath)
  layoutPath = the moviePath & fixPath(layoutPath)
  ProNotePath = the moviePath & fixPath(ProNotePath)
  saveMode = 99
end

on mouseUp me
  downloadList = []
  totalCount = photoDL.count + logoDL.count + bioDL.count + layoutDL.count + ProNoteDL.count
  if totalCount then
    totalByte = 0
    if photoDL.count then
      i = 1
      repeat while i <= photoDL.count
        endfile = photoDL[i] & photoExt
        thisFile = photoPath & endfile
        thisByte = baFileSize(thisFile)
        totalByte = totalByte + thisByte
        downloadList.append(thisFile)
        i = 1 + i
      end repeat
    end if
    if logoDL.count then
      i = 1
      repeat while i <= logoDL.count
        endfile = logoDL[i] & logoExt
        thisFile = logoPath & endfile
        thisByte = baFileSize(thisFile)
        totalByte = totalByte + thisByte
        downloadList.append(thisFile)
        i = 1 + i
      end repeat
    end if
    if bioDL.count then
      i = 1
      repeat while i <= bioDL.count
        endfile = bioDL[i] & bioExt
        thisFile = bioPath & endfile
        thisByte = baFileSize(thisFile)
        totalByte = totalByte + thisByte
        downloadList.append(thisFile)
        i = 1 + i
      end repeat
    end if
    if layoutDL.count then
      i = 1
      repeat while i <= layoutDL.count
        endfile = layoutDL[i] & layoutExt
        thisFile = layoutPath & endfile
        thisByte = baFileSize(thisFile)
        totalByte = totalByte + thisByte
        downloadList.append(thisFile)
        i = 1 + i
      end repeat
    end if
    if ProNoteDL.count then
      i = 1
      repeat while i <= ProNoteDL.count
        endfile = ProNoteDL[i] & ProNoteExt
        thisFile = ProNotePath & endfile
        thisByte = baFileSize(thisFile)
        totalByte = totalByte + thisByte
        downloadList.append(thisFile)
        i = 1 + i
      end repeat
    end if
    openDLMessage(totalCount, totalByte)
  end if
end
