property spriteNum, mySprite, pDirection, pUpperMask, pLowerMask, onMember, offMember, downmember, stopMember, otherStop, otherOff, oldCursor, firstSprite, lastSprite, startLoc, endLoc, totalRows, visibleRows, rowDistance, rowsMoved

on getPropertyDescriptionList
  description = [#pDirection: [#comment: "Which direction?", #default: "up", #range: ["up", "down"], #format: #string], #totalRows: [#comment: "Total number of rows", #default: 3, #format: #integer], #visibleRows: [#comment: "# of rows on screen", #default: 3, #format: #integer], #rowDistance: [#comment: "Pixel distance between rows", #default: 120, #format: #integer], #rowsMoved: [#comment: "How many rows to scroll on each mouse click", #default: 2, #format: #integer], #firstSprite: [#comment: "First sprite channel for scrolling", #default: 0, #format: #integer], #lastSprite: [#comment: "Last sprite channel for scrolling", #default: 0, #format: #integer], #pUpperMask: [#comment: "Upper mask sprite", #default: 0, #format: #integer], #pLowerMask: [#comment: "Lower mask sprite", #default: 0, #format: #integer]]
  return description
end

on beginSprite me
  mySprite = sprite(spriteNum)
  offMember = mySprite.member.number
  onMember = offMember + 1
  downmember = offMember + 2
  stopMember = offMember + 3
  if pDirection = "down" then
    otherStop = stopMember - 4
    otherOff = offMember - 4
  else
    if pDirection = "up" then
      otherStop = stopMember + 4
      otherOff = offMember + 4
      mySprite.member = stopMember
    end if
  end if
  oldCursor = mySprite.cursor
  totalDistance = rowDistance * (totalRows - visibleRows)
  startLoc = sprite(firstSprite).loc
  endLoc = startLoc - point(0, totalDistance)
end

on mouseEnter me
  if mySprite.member.number <> stopMember then
    if not (the mouseDown) then
      mySprite.member = onMember
    else
      mySprite.member = downmember
    end if
    mySprite.cursor = 280
  end if
end

on mouseLeave me
  mySprite.cursor = oldCursor
  if mySprite.member.number <> stopMember then
    mySprite.member = offMember
  end if
end

on mouseDown me
  if mySprite.member.number <> stopMember then
    mySprite.member = downmember
  end if
end

on mouseWithin me
  if mySprite.member.number <> stopMember then
    mySprite.member = onMember
    mySprite.cursor = 280
  else
    mySprite.cursor = oldCursor
  end if
end

on mouseUp me
  if mySprite.member.number <> stopMember then
    mySprite.member = offMember
    case pDirection of
      "down":
        Dir = -1
        sprite(spriteNum - 1).member = otherOff
      "up":
        Dir = 1
        sprite(spriteNum + 1).member = otherOff
    end case
    updateStage()
    inc = 20 * Dir
    currLoc = sprite(firstSprite).loc
    nextLoc = currLoc + point(0, Dir * rowDistance * rowsMoved)
    repeat while abs(sprite(firstSprite).locV - nextLoc.locV) >= abs(inc)
      i = firstSprite
      repeat while i <= lastSprite
        sprite(i).visible = 1
        sprite(i).loc = sprite(i).loc + point(0, inc)
        i = 1 + i
      end repeat
      if pDirection = "down" then
        if sprite(firstSprite).loc <= endLoc then
          nextMove = sprite(firstSprite).loc - endLoc
          i = firstSprite
          repeat while i <= lastSprite
            sprite(i).loc = sprite(i).loc - nextMove
            i = 1 + i
          end repeat
          mySprite.member = stopMember
          sprite(spriteNum - 1).member = otherOff
          updateStage()
          exit repeat
        end if
      end if
      if pDirection = "up" then
        if sprite(firstSprite).loc >= startLoc then
          nextMove = sprite(firstSprite).loc - startLoc
          i = firstSprite
          repeat while i <= lastSprite
            sprite(i).loc = sprite(i).loc - nextMove
            i = 1 + i
          end repeat
          mySprite.member = stopMember
          sprite(spriteNum + 1).member = otherOff
          updateStage()
          exit repeat
        end if
      end if
      updateStage()
    end repeat
    nextMove = sprite(firstSprite).loc - nextLoc
    i = firstSprite
    repeat while i <= lastSprite
      if mySprite.member.number <> stopMember then
        sprite(i).loc = sprite(i).loc - nextMove
      end if
      if sprite(i).intersects(pUpperMask) or sprite(i).intersects(pLowerMask) then
        sprite(i).visible = 0
      else
        sprite(i).visible = 1
      end if
      updateStage()
      i = 1 + i
    end repeat
    if pDirection = "down" then
      if sprite(firstSprite).loc <= endLoc then
        nextMove = sprite(firstSprite).loc - endLoc
        i = firstSprite
        repeat while i <= lastSprite
          sprite(i).loc = sprite(i).loc - nextMove
          i = 1 + i
        end repeat
        mySprite.member = stopMember
        sprite(spriteNum - 1).member = otherOff
        updateStage()
      end if
    end if
    if pDirection = "up" then
      if sprite(firstSprite).loc >= startLoc then
        nextMove = sprite(firstSprite).loc - startLoc
        i = firstSprite
        repeat while i <= lastSprite
          sprite(i).loc = sprite(i).loc - nextMove
          i = 1 + i
        end repeat
        mySprite.member = stopMember
        sprite(spriteNum + 1).member = otherOff
        updateStage()
      end if
    end if
  end if
end
